#include <stdlib.h>
#include "Arvore23.h"

extern void Arvore23LiberaNo (NODE_23_T *tree);

void Arvore23LiberaMemoriaDesalocaDados (NODE_23_T *tree)
{
	if (tree == NULL) return;
	Arvore23LiberaMemoriaDesalocaDados (tree->f[0]);
	Arvore23LiberaMemoriaDesalocaDados (tree->f[1]);
	Arvore23LiberaMemoriaDesalocaDados (tree->f[2]);
	if (tree->v[0] != NULL) free ((void *) tree->v[0]);
	if (tree->v[1] != NULL) free ((void *) tree->v[1]);
	Arvore23LiberaNo (tree);
}

/*
Alm de destruir a rvore, desaloca os ns que estavam
na rvore. Essa funo deve ser chamada apenas quando
houver certeza de que cada n foi alocado individualmente
com malloc, e no sero mais necessrios.
*/
void Arvore23DestroiDesalocaDados (ARVORE_23_T tree23)
{
	if (tree23 == NULL) return;
	Arvore23LiberaMemoriaDesalocaDados (tree23->tree);
	free (tree23);
}
