#include <stdio.h>
#include "Arvore23.h"

extern NODE_23_T *Arvore23AlocaNo (void);

NODE_23_T *Arvore23InsereRec (
	NODE_23_T *tree
	, int (*cmp)(const void *e1, const void *e2)
	, const void **novo_v
	, NODE_23_T **novo_f
	, const void **inseriu /* devolve o n anterior de mesma chave que foi substitudo, se existir */
)
{
	int comp;
	NODE_23_T *novo_irmao;
	int pos = -1; /* posicao a inserir novo elemento */

	/* Procurar posio correta do elemento */
	if ((comp = cmp (*novo_v, tree->v[0])) < 0) pos = 0;
	else if (comp == 0) {*inseriu = tree->v[0]; tree->v[0] = *novo_v; *novo_v = *novo_f = NULL; return tree;}
	else if (tree->v[1] == NULL || (comp = cmp (*novo_v, tree->v[1])) < 0) pos = 1;
	else if (comp == 0) {*inseriu = tree->v[1]; tree->v[1] = *novo_v; *novo_v = *novo_f = NULL; return tree;}
	else pos = 2;

	/* se nao for n folha, tentar inserir nos filhos antes */	
	if (tree->f[pos] != NULL) {
		tree->f[pos] = Arvore23InsereRec (tree->f[pos], cmp, novo_v, novo_f, inseriu);
		if (*novo_v == NULL) return tree;
	}

	if (pos == 0) {
		if (tree->v[1] == NULL) {
			tree->v[1] = tree->v[0];
			tree->f[2] = tree->f[1];
			tree->v[0] = *novo_v;
			tree->f[1] = *novo_f;
			*novo_v = NULL;
			*novo_f = NULL;
		}
		else {
			novo_irmao = Arvore23AlocaNo ();
			novo_irmao->v[0] = tree->v[1];
			novo_irmao->f[0] = tree->f[1];
			novo_irmao->f[1] = tree->f[2];
			tree->v[1] = tree->v[0];
			tree->f[2] = NULL;
			tree->f[1] = *novo_f;
			tree->v[0] = *novo_v;
			*novo_v = tree->v[1];
			tree->v[1] = NULL;
			*novo_f = novo_irmao;
		}
	}
	else if (pos == 1) {
		if (tree->v[1] == NULL) {
			tree->v[1] = *novo_v;
			tree->f[2] = *novo_f;
			*novo_v = NULL;
			*novo_f = NULL;
		}
		else {
			novo_irmao = Arvore23AlocaNo ();
			novo_irmao->v[0] = tree->v[1];
			novo_irmao->f[0] = *novo_f;
			novo_irmao->f[1] = tree->f[2];
			tree->v[1] = NULL;
			tree->f[2] = NULL;
			*novo_f = novo_irmao;
		}
	}
	else {
		novo_irmao = Arvore23AlocaNo ();
		novo_irmao->v[0] = *novo_v;
		novo_irmao->f[0] = tree->f[2];
		novo_irmao->f[1] = *novo_f;
		*novo_v = tree->v[1];
		*novo_f = novo_irmao;
		tree->v[1] = NULL;
		tree->f[2] = NULL;
	}
	return tree;
}

const void *Arvore23Insere (ARVORE_23_T tree23, const void *el)
{
	const void *novo_v;
	NODE_23_T *novo_f;
	NODE_23_T *nova_raiz;
	const void *inseriu;
	if (tree23 == NULL || el == NULL) return NULL;
	novo_v = el;
	novo_f = NULL;
	inseriu = NULL;
	if (tree23->tree != NULL) {
		tree23->tree = Arvore23InsereRec (tree23->tree, tree23->cmp, &novo_v, &novo_f, &inseriu);
		if (inseriu == NULL) tree23->n++;
	}
	else {
		tree23->n = 1;
	}
	if (novo_v == NULL) return inseriu;
	/* neste ponto, a rvore crescer um nvel (se vazia, passar a existir) */
	nova_raiz = Arvore23AlocaNo ();
	nova_raiz->v[0] = novo_v;
	nova_raiz->f[0] = tree23->tree;
	nova_raiz->f[1] = novo_f;
	tree23->tree = nova_raiz;
	return inseriu;
}
