#include <stdio.h>
#include "Arvore23.h"

const void *Arvore23Recupera (ARVORE_23_T tree23, const void *el)
{
	NODE_23_T *no;
	int comp;
	int (*cmp)(const void *, const void *);
	if (tree23 == NULL || el == NULL) return NULL;
	cmp = tree23->cmp;
	no = tree23->tree;
	while (no != NULL) {
		comp = cmp (el, no->v[0]);
		if (comp < 0) {no = no->f[0]; continue;}
		if (comp == 0) return no->v[0];
		if (no->v[1] == NULL) {no = no->f[1]; continue;}
		
		comp = cmp (el, no->v[1]);
		if (comp < 0) {no = no->f[1]; continue;}
		if (comp == 0) return no->v[1];
		no = no->f[2];
	}
	return NULL;
}

/* Devolve 1 se valor existe na arvore, e 0 caso contrrio. */
int Arvore23Contem (ARVORE_23_T tree23, const void *valor)
{
	if (Arvore23Recupera (tree23, valor) == NULL) return 0;
	return 1;
}
